package ru.themixray.puton;

import org.bukkit.Bukkit;
import org.bukkit.command.*;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;
import ru.themixray.puton.command.BootsCommand;
import ru.themixray.puton.command.ChestplateCommand;
import ru.themixray.puton.command.HelmetCommand;
import ru.themixray.puton.command.LeggingsCommand;
import ru.themixray.puton.listener.SwapItemListener;
import ru.themixray.puton.util.UnrealConfig;

import java.lang.reflect.Field;
import java.util.List;

public final class Main extends JavaPlugin implements Listener {
    public void onEnable() {
        Config.loadConfig(new UnrealConfig(this, getDataFolder(), "config.yml"));
        Bukkit.getPluginManager().registerEvents(new SwapItemListener(), this);
        registerCommand(getCommand("helmet"), Config.HELMET_COMMANDS, new HelmetCommand());
        registerCommand(getCommand("chestplate"), Config.CHESTPLATE_COMMANDS, new ChestplateCommand());
        registerCommand(getCommand("leggings"), Config.LEGGINGS_COMMANDS, new LeggingsCommand());
        registerCommand(getCommand("boots"), Config.BOOTS_COMMANDS, new BootsCommand());
    }

    public CommandMap getCommandMap() {
        try {
            Field bukkitCommandMap = Bukkit.getServer().getClass().getDeclaredField("commandMap");
            bukkitCommandMap.setAccessible(true);
            return (CommandMap) bukkitCommandMap.get(Bukkit.getServer());
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public void registerCommand(PluginCommand command, List<String> names, CommandExecutor executor) {
        if (names.isEmpty()) {
            command.unregister(getCommandMap());
            return;
        }
        command.setExecutor(executor);
        command.setName(names.get(0));
        if (names.size() > 1) command.setAliases(names.subList(1, names.size()));
        command.setTabCompleter((a, b, c, d) -> List.of());
    }
}